#include <iostream>
#include <set>
#include <iterator>
#include <boost/date_time/posix_time/posix_time.hpp>
using namespace std;
using namespace boost::posix_time;

//---------------------------------------------------------
// \f[^

struct Plan
{
    string      name; // O
    time_period time; // Jn-I
};

bool operator<( const Plan& lhs, const Plan& rhs )
{
    return lhs.time < rhs.time;
}

ostream& operator<<( ostream& os, const Plan& p )
{
    return os << p.name <<  " : " << p.time;
}

struct conflicts_with
{
    time_period time;
    conflicts_with( const Plan& p ) : time(p.time) {}
    bool operator()( const Plan& rhs ) const
    {
        // Ԃ̋ԂƋԂdȂĂȂ`FbN
        return !time.intersection( rhs.time ).is_null();
    }
};

//---------------------------------------------------------
// C

string ask( const string& question )
{
    string answer;
    cout << question << ' ';
    getline( cin, answer );
    return answer;
}

int main()
{
    set<Plan> plans;
    while( cin )
    {
        string name = ask( "ǉ\́H" );
        if( name.empty() )
        {
            // S\\
            copy( plans.begin(), plans.end(), ostream_iterator<Plan>(cout,"\n") );
            continue;
        }

        // 񂩂ptimetime_duration𐶐
        string start  = ask( "\[" + name + "]̊JńH" );
        string length = ask( "鎞Ԃ́H" );
        ptime beginTime = time_from_string( start );
        ptime endTime   = beginTime + duration_from_string( length );
        Plan p = { name, time_period(beginTime, endTime) };

        // ̗\ƏdȂĂȂ`FbNA\ǉ
        set<Plan>::iterator it =
            find_if( plans.begin(), plans.end(), conflicts_with(p) );
        if( it != plans.end() )
            cout << "- \" << *it << "ƂԂĂ܂" << endl;
        else
            plans.insert( p );
    }
    return 0; 
} 
