#include <iostream>
#include <boost/asio.hpp>
#include <boost/bind.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>
using namespace std;
using namespace boost;
using namespace boost::asio;
using namespace boost::posix_time;

void handler( const boost::system::error_code& e )
{
    if(e) cout << "[3] LZ" << endl;
    else  cout << "[3] 3bI" << endl;
}

void canceler( const boost::system::error_code& e, deadline_timer* t )
{
    t->cancel();
    if(e) cout << "[2] LZ" << endl;
    else  cout << "[2] 2bI" << endl;
}

int main()
{
    io_service io;

    deadline_timer t1(io, seconds(3));
    t1.async_wait( &handler );

    deadline_timer t2(io, seconds(2));
    t2.async_wait( bind(&canceler, _1, &t1) );

    io.run();
}
