#include <boost/iostreams/concepts.hpp>
#include <boost/iostreams/operations.hpp>
using namespace boost::iostreams;
namespace  io = boost::iostreams;

// Base64́A6bit ϊe[u
char tbl[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

class base64_encoder : public output_filter
{
public:
    base64_encoder() : index(0) {}

private:
    char buf[3];
    int  index;

public:
    template<typename Sink>
      bool put( Sink& snk, int c )
      {
          buf[index++] = c; // obt@ɂ߂
          if( index == 3 )  // 3܂
          {
              // 6bitɋ؂Ȃϊ4o
              io::put( snk, tbl[(buf[0]>>2)&0x3f] );
              io::put( snk, tbl[(buf[0]<<4)&0x30 | (buf[1]>>4)&0x0f] );
              io::put( snk, tbl[(buf[1]<<2)&0x3c | (buf[2]>>6)&0x03] );
              io::put( snk, tbl[(buf[2])   &0x3f] );
              index = 0;
          }
          return true;
      }

    template<typename Sink>
      void close( Sink& snk )
      {
          if( index > 0 ) // ]肪
          {
              // óB]ȂƂ͂0Ao͂'='Ŗ߂̂Base64
              for(int j=index; j<3; ++j) buf[j] = 0;
              io::put( snk, tbl[(buf[0]>>2)&0x3f] );
              io::put( snk, tbl[(buf[0]<<4)&0x30 | (buf[1]>>4)&0x0f] );
              io::put( snk, index<=1 ? '=' : tbl[(buf[1]<<2)&0x3c | (buf[2]>>6)&0x03] );
              io::put( snk, index<=2 ? '=' : tbl[(buf[2])   &0x3f] );
          }
      }
};

#include <iostream>
#include <string>
#include <boost/iostreams/filtering_stream.hpp>
using namespace std;

int main()
{
    filtering_ostream s;
    s.push(base64_encoder());
    s.push(cout);
    string str;
    while( getline(cin, str) )
        s << str << endl;
}
