#include <iostream>
#include <fstream>
#include <boost/serialization/serialization.hpp>
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
using namespace std;
using namespace boost::archive;


struct List_t
{
    int     data;
    List_t* next;

    List_t() {}
    List_t(int d, List_t* n) : data(d), next(n) {}

private:
    friend class boost::serialization::access;
    template<class Archive>
      void serialize( Archive& ar, unsigned int ver )
      {
          ar & data;
          ar & next;
      }
};

typedef List_t* List;

List empty()             { return 0; }
List cons(int d, List n) { return new List_t(d, n); }

namespace boost {
  namespace serialization {
    template<class Archive>
      void save_construct_data( Archive& ar, const List_t* ptr, unsigned int ver )
      {
          ar << ptr->data;
          ar << ptr->next;
      }

    template<class Archive>
      void load_construct_data( Archive& ar, List_t* ptr, unsigned int ver )
      {
          int  h;
          List t;
          ar >> h >> t;
          ::new(ptr) List_t(h, t); // placement new ::
                                   //    new(AhX) RXgN^
      }
  }
}

int main()
{
    // ۑ
    {
        List a = cons(1, cons(2, cons(3, empty())));
        List b = a->next;

        text_oarchive(ofstream("save.dat")) << (const List&)a << (const List&)b;
    }

    // 
    {
        List a, b;
        text_iarchive(ifstream("save.dat")) >> a >> b;

        // łĂ邱ƂmF
        for(List p=a; p; p=p->next) { cout << p->data << " "; } cout << endl;
        b->data = 999;
        for(List p=a; p; p=p->next) { cout << p->data << " "; } cout << endl;
    }
}
