#include <iostream>
#include <vector>
#include <fstream>
#include <boost/crc.hpp>
using namespace std;
using namespace boost;

int err( const char* msg, int e )
{
    cerr << "error: " << msg << endl;
    return e;
}

unsigned short getWord( const char* ptr )
{
	return static_cast<unsigned char>(ptr[0])
        + (static_cast<unsigned char>(ptr[1])<<8);
}

int main( int argc, char* argv[] )
{
    if( argc != 2 )
        return err("usage: crcchk archive.lzh", 1);

    // t@Cǂݍ
    ifstream arc( argv[1], ios::binary );
    if( !arc )
        return err("LHaɂJ܂ł", 2);

    // ʃwb_i24bytejǂݍ
    vector<char> buf( 24 );
    if( !arc.read( &buf[0], buf.size() ) )
        return err("wb_̓ǂݎɎs܂", 3);
    if( buf[20] != 0x02 )
        return err("LV2wb_݂̂ɑΉĂ܂", 4);

    // CRCvZJnBLHaCRCvŹA
    // u16rbgE0x8005Ev
    crc_optimal<16,0x8005,0,0,true,true> lha_crc;
    lha_crc.process_bytes( &buf[0], buf.size() );

    // gwb_Bgwb_
    //   N    : 2   byte
    //   type : 1   byte
    //   data : N-3 byte
    // Ƃ`B
    unsigned short hdrcrc = 0;
    char           size_field[2];
    while( arc.read(size_field, 2) )
    {
         lha_crc.process_bytes( size_field, 2 );

         const long size = getWord( size_field );
         if( size < 2 )
             break;

         buf.resize( size-2 );
         arc.read( &buf[0], size-2 );
         if( buf[0] == 0x00 ) // CRĈwb_
         {
             hdrcrc = getWord( &buf[1] );
             buf[1] = buf[2] = 0;
         }
         lha_crc.process_bytes( &buf[0], buf.size() );
    }

    // vZꂽCRCƁAwb_ɏ܂ꂽlr
    if( lha_crc.checksum() == hdrcrc )
        cout << "CRC͈v܂" << endl;
    else
        cout << "CRCv܂" << endl << hex
             << "  vZʁF"   << lha_crc.checksum()
             << "  wb_F" << hdrcrc << endl;
    return 0;
}
