#include <iostream>
#include <string>
#include <memory>
#include <boost/any.hpp>
using namespace std;
using namespace boost;

// bZ[W󂯓n̔ėpC^[tFCX
class MessageReceiver
{
public:
    virtual void do_message( int msg, any data ) = 0;
    virtual ~MessageReceiver() {}
};

enum { PRINT_STRING, SET_REPEAT_COUNT };

// bZ[W̎BڍׂMessageReceiverC^[tFCX
// ɉBAOɌȂB
MessageReceiver* create_receiver()
{
    class MyReceiver : public MessageReceiver
    {
        int rep;
        virtual void do_message( int msg, any data )
        {
            switch( msg )
            {
            case PRINT_STRING:
                for(int i=0; i!=rep; ++i)
                    cout << any_cast<string>(data);
                cout << endl;
                break;
            case SET_REPEAT_COUNT:
                rep = any_cast<int>(data);
                break;
            }
        }
    public:
        MyReceiver() : rep(1) {}
    };
    return new MyReceiver;
}

int main()
{
    // bZ[WM̗
    auto_ptr<MessageReceiver> recv( create_receiver() );
    recv->do_message( PRINT_STRING,     string("") );
    recv->do_message( SET_REPEAT_COUNT, 2 );
    recv->do_message( PRINT_STRING,     string("ɂ[") );
    return 0;
}
