#include <iostream>
#include <algorithm>
#include <string>
#include <cctype>
#include <boost/iterator/iterator_adaptor.hpp>
using namespace std;
using namespace boost;

class lower_char_iterator
  : public iterator_adaptor<lower_char_iterator, string::const_iterator,
                            use_default, use_default, char>
{
public:
    typedef iterator_adaptor<lower_char_iterator, string::const_iterator,
                             use_default, use_default, char> super;
    lower_char_iterator( string::const_iterator it ) : super( it ){}

private:
    friend class boost::iterator_core_access;
    char dereference() const { return tolower( *this->base_reference() ); }
};

void print( char c ) { cout << c; }

int main()
{
    string s("HEllO");
    for_each( 
      lower_char_iterator(s.begin()),
      lower_char_iterator(s.end()),
      &print );
    return 0;
}
