#include <iostream>
#include <boost/multi_array.hpp>
#include <boost/progress.hpp>
using namespace std;
using namespace boost;

int main()
{
    // zuw肵č\z
    static const int N = 7000;
    multi_array<int,2> c( extents[N][N], c_storage_order() );
    multi_array<int,2> f( extents[N][N], fortran_storage_order() );

    {
        progress_timer t;
        cout << "x-y : C : ";
        for( int x=0; x!=N; ++x )
            for( int y=0; y!=N; ++y )
                c[x][y] = x + y;
    }
    {
        progress_timer t;
        cout << "x-y : Fortran : ";
        for( int x=0; x!=N; ++x )
            for( int y=0; y!=N; ++y )
                f[x][y] = x + y;
    }
    {
        progress_timer t;
        cout << "y-x : C : ";
        for( int y=0; y!=N; ++y )
            for( int x=0; x!=N; ++x )
                c[x][y] = x + y;
    }
    {
        progress_timer t;
        cout << "y-x : Fortran : ";
        for( int y=0; y!=N; ++y )
            for( int x=0; x!=N; ++x )
                f[x][y] = x + y;
    }
    return 0;
}
